{$N+}
program teapot;
{CG&A, January 1987}

uses Dos,Crt,GritN,GritMath,nemostuf;

const
   degree = 3;
   duck_count = 306;
   patch_count = 32;
type
   extended = real;
   duck_type = record x,y,z: real end;
   duck_index_type = 1..duck_count;
   duck_array_type = array[1..duck_count] of duck_type;
   patch_type = array[0..degree,0..degree] of duck_index_type;
   patch_array_type = array[1..patch_count] of patch_type;
var
   ducks: duck_array_type;
   patches: patch_array_type;
   q,s: string;
   x1,y1: extended;   {beginpunt DrawLine gedefinieerd door moveto}
   phi,psi,r,phideg,psideg: extended;
   pmatrix: MAT44;
   ade: byte;
   eerstekeer: boolean;
   resolution: integer;
   tel,incr: integer;
label phidraai,psidraai,lus;

function rad(hoek: extended): extended;
begin rad:=hoek*pi/180 end;

procedure projmat(phi,psi,r: extended; var pmat: MAT44);
{wereld-naar-clippingcoordinaten matrix}
const
   s = 0.30;
   d = 1.0;
   f = 1000.0;
var smat: MAT44;
begin
   Rotz3D(-phi,pmat);
   Rotx3D(psi,smat); {NB +psi hoewel coord.transf, dit ivm noorderbr def}
   MMprod4(smat,pmat,pmat);
   Transl3D(0,0,-r,smat);
   MMprod4(smat,pmat,pmat);
   RtoL(smat);
   MMprod4(smat,pmat,pmat);
   EyeToClip(s,d,f,smat);
   MMprod4(smat,pmat,pmat)
end;

procedure WorldToScreen(xw,yw,zw: real; var xs,ys: extended);
{berekent de projectie van het gegeven punt}
var
   c,world: VEC4;
begin
   world[1]:=xw; world[2]:=yw; world[3]:=zw; world[4]:=1;
   MVprod4(pmatrix,world,c);
   xs:=c[1]/c[4];
   ys:=c[2]/c[4]
end;


procedure move_to(x,y,z: real);
{x1 en y1 zijn globals}
begin
   WorldToScreen(x,y,z,x1,y1);
end;

procedure draw_to(x,y,z: real);
var x2,y2: extended;
begin
   WorldToScreen(x,y,z,x2,y2);
   DrawLine(x1,y1,x2,y2,lightgreen);
   x1:=x2; y1:=y2;
end;

procedure blend_vector(d0,d1,d2,d3: duck_type; t: real; var result: duck_type);
begin
   result.x:=d0.x*(1-t)*(1-t)*(1-t) + d1.x*3*t*(1-t)*(1-t) + d2.x*3*t*t*(1-t) + d3.x*t*t*t;
   result.y:=d0.y*(1-t)*(1-t)*(1-t) + d1.y*3*t*(1-t)*(1-t) + d2.y*3*t*t*(1-t) + d3.y*t*t*t;
   result.z:=d0.z*(1-t)*(1-t)*(1-t) + d1.z*3*t*(1-t)*(1-t) + d2.z*3*t*t*(1-t) + d3.z*t*t*t
end;

procedure display_curve(d0,d1,d2,d3: duck_type; steps: integer);
var
   t,step: real;
   temp: duck_type;
begin
    step:=1/steps;
    t:=step;
    move_to(d0.x,d0.y,d0.z);
    while t<(1 + step/2) do
       begin
          blend_vector(d0,d1,d2,d3,t,temp);
          draw_to(temp.x,temp.y,temp.z);
          t:=t+step
       end
end;

procedure display_patch(var patch: patch_type; steps: integer);
var
    t: real;
    step: real;
    d0,d1,d2,d3: duck_type;
begin
    step:=1/steps;
    t:=0;
    while t<(1 + step/2) do
         begin
           blend_vector
                   (ducks[patch[0,0]],ducks[patch[0,1]],ducks[patch[0,2]],ducks[patch[0,3]],t,d0);
           blend_vector
                   (ducks[patch[1,0]],ducks[patch[1,1]],ducks[patch[1,2]],ducks[patch[1,3]],t,d1);
           blend_vector
                   (ducks[patch[2,0]],ducks[patch[2,1]],ducks[patch[2,2]],ducks[patch[2,3]],t,d2);
           blend_vector
                   (ducks[patch[3,0]],ducks[patch[3,1]],ducks[patch[3,2]],ducks[patch[3,3]],t,d3);

           display_curve(d0,d1,d2,d3,steps);

           blend_vector
                   (ducks[patch[0,0]],ducks[patch[1,0]],ducks[patch[2,0]],ducks[patch[3,0]],t,d0);
           blend_vector
                   (ducks[patch[0,1]],ducks[patch[1,1]],ducks[patch[2,1]],ducks[patch[3,1]],t,d1);
           blend_vector
                   (ducks[patch[0,2]],ducks[patch[1,2]],ducks[patch[2,2]],ducks[patch[3,2]],t,d2);
           blend_vector
                   (ducks[patch[0,3]],ducks[patch[1,3]],ducks[patch[2,3]],ducks[patch[3,3]],t,d3);

           display_curve(d0,d1,d2,d3,steps);

           t:=t+step
        end
end;

procedure display_patches(steps: integer);
var
   index: integer;
begin
   for index:=1 to patch_count do display_patch(patches[index],steps)
end;


procedure load_ducks;
var
   i,vertex_number: integer;
   f: text;
   s: string;
begin
   assign(f,'teapot.geom');
   reset(f);
   for i:=1 to duck_count do
       begin
         read(f,vertex_number,ducks[i].x,ducks[i].y,ducks[i].z);
         readln(f);
         if vertex_number<>i then begin writeln('load_ducks fout bij punt ',i:5); halt end;
       end;
   close(f)
end;

function max2(a,b: real): real;
begin
   if a>b then max2:=a else max2:=b
end;

function max4(a,b,c,d: real): real;
var t1,t2: real;
begin
   t1:=max2(a,b);
   t2:=max2(c,d);
   max4:=max2(t1,t2)
end;

function min2(a,b: real): real;
begin
   if a<=b then min2:=a else min2:=b
end;

function min4(a,b,c,d: real): real;
var t1,t2: real;
begin
   t1:=min2(a,b);
   t2:=min2(c,d);
   min4:=min2(t1,t2)
end;

procedure normeer;
var
    xsom,ysom,zsom,xgem,ygem,zgem,ma,mi: real;
    i: integer;
    s: string;
begin
    mi:=1000; ma:=-1000;
    for i:=1 to duck_count do
        with ducks[i] do
           begin
             xsom:=xsom+x;
             ysom:=ysom+y;
             zsom:=zsom+z
           end;
    xgem:=xsom/duck_count;
    ygem:=ysom/duck_count;
    zgem:=zsom/duck_count;
    for i:=1 to duck_count do
       with ducks[i] do
          begin
            x:=x-xgem;
            y:=y-ygem;
            z:=z-zgem;
            ma:=max4(x,y,z,ma);
            mi:=min4(x,y,z,mi);
          end;
    ma:=max2(ma,-mi);
    for i:=1 to duck_count do
       with ducks[i] do
         begin
             x:=x/ma;
             y:=y/ma;
             z:=z/ma;
         end;
end;

procedure load_patches;
var
   i,j,k,patch_number: integer;
   f: text;
   patch: patch_type;
   s: string;
begin
   assign(f,'teapot.topo');
   reset(f);
   for i:=1 to patch_count do
      begin
         read(f,patch_number);
         for j:=0 to 3 do
                 for k:=0 to 3 do read(f,patch[j,k]);
         readln(f);
         if patch_number<>i then begin writeln('load_patches fout bij punt ',i:5); halt end;
         patches[i]:=patch;
      end;
    close(f)
end;


{main}
begin
   tel:=1;
   hello('Programma 7', 'De theepot van Newell', 'nl');
   load_ducks;
   normeer;
   load_patches;
   SetUpGraphics;
   SetViewport(0.15,0.0, 0.85,0.7,0);
   SetWindow(-2,-2,2,2);
   phideg:=5; psideg:=35; r:=2.0; resolution:=4;
   phi:=phideg*pi/180;
   psi:=(psideg-90)*pi/180;
   projmat(phi,psi,r,pmatrix);
   display_patches(resolution);
   Prompt('druk een toets om verder te gaan:');
   Wait(-1,ade);
   {ronddraaien vanuit bovenstaande positie}

phidraai:   phideg:=5; tel:=tel+1;
   for incr:=1 to 12 do
   begin
   Wait(1,ade);
   RemoveViewport;
   phideg:=phideg+30; psideg:=35;
   phi:=phideg*pi/180;
   psi:=(psideg-90)*pi/180;
   SetViewport(0.15,0.0, 0.85,0.7, 0);
   SetWindow(-2,-2,2,2);
   projmat(phi,psi,r,pmatrix);
   display_patches(resolution);
   end;
   goto lus;

psidraai:   psideg:=35; tel:=tel+1;
   for incr:=1 to 12 do
   begin
   Wait(1,ade);
   RemoveViewport;
   psideg:=psideg+30; phideg:=5;
   phi:=phideg*pi/180;
   psi:=(psideg-90)*pi/180;
   SetViewport(0.15,0.0, 0.85,0.7, 0);
   SetWindow(-2,-2,2,2);
   projmat(phi,psi,r,pmatrix);
   display_patches(resolution);
   end;

lus:   Prompt('toets <s> voor stoppen, <d> voor draaien, <k> voor kantelen:');
   Wait(-1,ade);
   if ade=ord('d') then goto phidraai
   else if ade=ord('k') then goto psidraai
   else if ade=ord('s') then begin DoneGraphics; halt end
   else goto lus;
end.
