{$N+}

program woerden;
{16 juni 1986 rev maart 1991, rev 2 1997 rev 3 2007}

uses  Dos,Crt,GritN,cmstuf;

type punt = record x,y: real end;
     puntarray = array[1..50] of punt;
     lijn = record first_id,last_id: integer end;
     triple = array[1..3] of real;
var i,vertnum,knop,index: integer;
    s: puntarray;
    uu,vv: real;
    ade: byte;
    ok: boolean;

function inprod(a,b: triple): real;
begin
    inprod:=a[1]*b[1] + a[2]*b[2] + a[3]*b[3]
end;

procedure dual(p,q: triple; var l: triple);
{p, q punten, l hun verbindingslijn}
begin
    l[1]:= p[2]-q[2];
    l[2]:=-p[1]+q[1];
    l[3]:= p[1]*q[2]-p[2]*q[1];
end;


function rechtsom(id1,id2,id3: integer): boolean;
var m1,m2,n1,n2,p1,p2,q: real;
begin
    with s[id1] do begin m1:=x; m2:=y end;
    with s[id2] do begin n1:=x; n2:=y end;
    with s[id3] do begin p1:=x; p2:=y end;
    q:=(n2-p2)*m1 + (p1-n1)*m2 + (n1*p2 - p1*n2);
    rechtsom:=q<0;
end;

function rechtsvan(l: lijn; id: integer): boolean;
var m1,m2,n1,n2,p1,p2,q: real;
begin
    if (id=l.first_id) or (id=l.last_id) then rechtsvan:=false
    else
      begin
         with s[id] do begin m1:=x; m2:=y end;
         with l do
            begin
               n1:=s[first_id].x; n2:=s[first_id].y;
               p1:=s[last_id].x; p2:=s[last_id].y
            end;
         q:=(n2-p2)*m1 + (p1-n1)*m2 + (n1*p2 - p1*n2);
         rechtsvan:= q<0
      end
end;

(************************ intersect **************************)

function intersect(k,l: lijn): boolean;
{onderzoekt of k en l elkaar snijden}
var a,b,a1,a2,b1,b2: triple;
    aba,bab: boolean;
begin {intersect}
    {test for common vertex}
    if (k.first_id = l.first_id) or
       (k.first_id = l.last_id) or
       (k.last_id = l.first_id) or
       (k.last_id = l.last_id) then
           begin intersect:=false; exit end;
    {test for intersection}
    a1[1]:=s[k.first_id].x; a1[2]:=s[k.first_id].y; a1[3]:=1;
    a2[1]:=s[k.last_id].x;  a2[2]:=s[k.last_id].y;  a2[3]:=1;
    b1[1]:=s[l.first_id].x; b1[2]:=s[l.first_id].y; b1[3]:=1;
    b2[1]:=s[l.last_id].x;  b2[2]:=s[l.last_id].y;  b2[3]:=1;
    dual(a1,a2,a); dual(b1,b2,b);
    aba:=(inprod(b,a1) * inprod(b,a2)) < 0;
    bab:=(inprod(a,b1) * inprod(a,b2)) < 0;
    intersect:=bab and aba
end; {intersect}


(***********************TRIANGULATE*************************)

function triangulate: boolean;
{triangulatie volgens Woerdenweber, CG&A nov 1983}

var nu,numin,nuplus: integer;
    edge1,edge2,edge3: lijn;
    tr: boolean;

procedure delete;
var i: integer;
begin
    for i:=nu to vertnum-1 do s[i]:=s[i+1];
    vertnum:=vertnum-1
end;


function snijdend: boolean;
var test: lijn;
    sn: boolean;
    i,n1,n2: integer;
label 10;
begin
    sn:=false;
    with edge1 do
       begin
           first_id:=numin; last_id:=nu
       end;
    with edge2 do
       begin
           first_id:=nu; last_id:=nuplus
       end;
    with edge3 do
       begin
           first_id:=nuplus; last_id:=numin
       end;
    for i:=0 to vertnum-3 do
       begin
          n1:=(nuplus+i); if n1>vertnum then n1:=n1-vertnum;
          n2:=(nuplus+i+1); if n2>vertnum then n2:=n2-vertnum;
          with test do begin first_id:=n1; last_id:=n2 end;
          if intersect(test,edge1) or
             intersect(test,edge2) or
             intersect(test,edge3) then
               begin
                  sn:=true;
                  goto 10
               end
       end;
10: snijdend:=sn;
end;


function leeg: boolean;
{kijk of de testdriehoek geen andere hoekpunten bevat}
var i,j: integer;
    vol: boolean;
label 20;
begin {leeg}
    vol:=false;
    for i:=1 to vertnum-3 do
      begin
         j:=nuplus+1; if j>vertnum then j:=j-vertnum;
         if rechtsvan(edge1,j) and
            rechtsvan(edge2,j) and
            rechtsvan(edge3,j) then
               begin
                  vol:=true;
                  goto 20
               end
      end;
20: leeg:=not vol
end;


function driehoek: boolean;
var xx,yy: array[1..3] of real;
    q: string;
    i: integer;
begin
    if nu=1 then numin:=vertnum else numin:=nu-1;
    nuplus:=nu+1; if nuplus>vertnum then nuplus:=nuplus-vertnum;
    tr:=rechtsom(numin,nu,nuplus) and (not snijdend) and leeg;
    driehoek:=tr;
    if tr then
      begin
         xx[1]:=s[numin].x;   yy[1]:=s[numin].y;
         xx[2]:=s[nu].x;      yy[2]:=s[nu].y;
         xx[3]:=s[nuplus].x;  yy[3]:=s[nuplus].y;
         Polyline(@xx,@yy,3,yellow,closed)
      end
end;

begin {triangulate}
    nu:=0;
    i:=0;
    repeat
       i:=i+1;
       nu:=(nu+1); if nu>vertnum then nu:=nu-vertnum;
       if driehoek then delete
    until (vertnum<3) or (i>1000); {i tbv timeout bij verkeerde orientatie}
    triangulate:=(vertnum<3);
end;

(********************************* MAIN ****************************)

begin {woerden}
    hello('Program 10',
        'Another polygon triangulation',
        'uk');
    SetupGraphics;
    SetViewport(0.15,0, 0.85,0.7,white);
    SetWindow(0,0, 0.7,0.7);
    REPEAT
    ClearViewport;
    Prompt('Click vertex point in clockwise order. Right-click AFTER the last point');
    i:=1;
        Locator(uu,vv,knop);
        Marker(uu,vv,dot,lightred);
        s[1].x:=uu; s[1].y:=vv;
    repeat
        Locator(uu,vv,knop);
        if knop<>2 then
          begin
             Marker(uu,vv,dot,lightred);
             ArrowLine(s[i].x,s[i].y,uu,vv,lightgreen);
             i:=i+1;
             s[i].x:=uu;
             s[i].y:=vv
          end;
    until knop=2;
    ArrowLine(s[i].x,s[i].y,s[1].x,s[1].y,lightgreen);
    vertnum:=i;
    Prompt('Push left mouse button to start the triangulation');
    Wait(-2,ade);
    Prompt('');
    ok:=triangulate;
    if not ok then
      begin
        Prompt('Too complex or wrong (ccw) orientation; click left to continue');
        Wait(-2,ade)
      end;
    Prompt('Click left to continue, right to stop');
    Wait(-2,ade);
    UNTIL ade=2;
    DoneGraphics
end.
